<script setup>
import { ref } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";
import LOGO from "@/assets/adaptor_login.svg";

const store = useStore();
const router = useRouter();
const username = ref(undefined);
const password = ref(undefined);
const showError = ref(false);
const loading = ref(false);

function authenticate() {
  loading.value = true;
  showError.value = false;
  store
    .dispatch("adaptor/tryAuth", {
      username: username.value,
      password: password.value,
    })
    .then((authenticated) => {
      if (authenticated) {
        setTimeout(() => {
          loading.value = false;
          showError.value = false;
          router.go(); // Reload route with credentials
        }, 100); // Note: timeout only for UX
      } else {
        loading.value = false;
        showError.value = true;
      }
    });
}
</script>

<template>
  <div class="overlay is-flex is-justify-content-center is-align-items-center">
    <div class="box p-5 has-border">
      <figure class="image mb-5">
        <img :src="LOGO" alt="Adaptor Login Image" />
      </figure>
      <header class="level">
        <div class="level-left">
          <div class="level-item">
            <h5 class="title is-size-5">LOGIN</h5>
          </div>
          <div class="level-item">
            <Icon
              class="has-text-grey"
              :icon="'help-circle'"
              :tooltip="`Need credentials?\nContact your adaptor:ex admin!`"
              :interactive="false"
            />
          </div>
        </div>
      </header>
      <div class="content" @keyup.enter="authenticate">
        <div class="field">
          <!-- <label class="label">Username</label> -->
          <div class="control has-icons-left">
            <input v-model="username" class="input is-link" type="text" placeholder="username" autofocus />
            <span class="icon is-small is-left">
              <Icon :icon="'user'" :interactive="false" />
            </span>
          </div>
        </div>

        <div class="field">
          <!-- <label class="label">Password</label> -->
          <div class="control has-icons-left">
            <input v-model="password" class="input is-link" type="password" placeholder="password" />
            <span class="icon is-small is-left">
              <Icon :icon="'lock'" :interactive="false" />
            </span>
          </div>
        </div>
        <div class="field">
          <div class="control">
            <p v-if="showError" class="help is-danger">Unknown username or wrong password.</p>
            <button class="button is-link" :class="{ 'is-loading': loading }" @click.stop="authenticate">LOGIN</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
